#
# spec file for package mod_perl (Version 1.26)
#
# Copyright (c) 2002 SuSE Linux AG, Nuernberg, Germany.
# This file and all modifications and additions to the pristine
# package are under the same license as the package itself.
#
# please send bugfixes or comments to feedback@suse.de.
#

# neededforbuild  apache-devel-packages mod_ssl perl perl-Digest-MD5 perl-HTML-Parser perl-MIME-Base64 perl-Tie-IxHash perl-URI perl-libnet perl-libwww-perl
# usedforbuild    aaa_base aaa_dir aaa_version base bash bindutil bison bzip cpio cpp cyrus-sasl db devs diffutils e2fsprogs file fileutils findutils flex gawk gdbm-devel glibc glibc-devel glibc-locale gpm gppshare grep groff gzip kbd less m4 make man mktemp modutils ncurses ncurses-devel net-tools netcfg pam-devel pam-modules patch ps rcs readline sendmail sh-utils shadow strace syslogd sysvinit texinfo textutils timezone unzip util-linux vim apache apache-devel autoconf automake binutils cracklib expat gcc gdbm gettext libtool libz mm mod_ssl openssl pam perl perl-Digest-MD5 perl-HTML-Parser perl-MIME-Base64 perl-Tie-IxHash perl-URI perl-libnet perl-libwww-perl rpm

Name:         mod_perl
%define apache_mmn        %(MMN=$(apxs -q LIBEXECDIR)/MMN; test -x $MMN && $MMN)
%define apache_libexecdir %(apxs -q LIBEXECDIR)
%define apache_sysconfdir %(apxs -q SYSCONFDIR)
%define apache_includedir %(apxs -q INCLUDEDIR)
%define apache_serverroot %(apxs -q PREFIX)
%define version_perl      %(rpm -q --queryformat '%%{version}' perl)
Summary:      Embedded Perl for Apache
Group:        Productivity/Networking/Web/Servers
Autoreqprov:  on
License:      Other License(s), see package
Requires:     apache, perl = %{version_perl} %{apache_mmn}
Requires:     perl-Digest-MD5 perl-HTML-Parser perl-MIME-Base64 perl-Tie-IxHash 
Requires:     perl-URI perl-libnet perl-libwww-perl
Autoreqprov:  on
Version:      1.26
Release:      347
Source0:      http://www.cpan.org/authors/id/D/DO/DOUGM/%{name}-%{version}.tar.bz2
Source1:      http://www.cpan.org/modules/by-module/Apache/Apache-%{name}_guide-1.29.tar.bz2
Patch:        %{name}-%{version}.dif
URL:          http://perl.apache.org/
Icon:         %{name}.xpm
BuildRoot:    %{_tmppath}/%{name}-%{version}-build

%description
The Apache/Perl integration project brings together the full power of
the Perl programming language and the Apache HTTP server.


With mod_perl it is possible to write Apache modules entirely in
Perl. In addition, the persistent interpreter embedded in the server
avoids the overhead of starting an external interpreter and the
penalty of Perl start-up time.

SuSE series: n

%prep
%setup -n %{name}-%{version}
%setup -n %{name}-%{version} -c %{name}-%{version} -a 1 -T -D
%patch
#
# replace wrong location of perl
#
for file in `find . -type f -exec fgrep -l /local/bin/perl {} \;`; do
    cat $file | \
    sed -e 's+/user/local/bin/perl+%{_bindir}/perl+' \
	-e 's+/usr/local/bin/perl+%{_bindir}/perl+' > tmp_file;
    mv tmp_file $file;
    echo "Patched Perl path in: $file";
done

%build
eval `perl -V:installarchlib`
if [ -e $installarchlib/perllocal.pod ]; then
    mv $installarchlib/perllocal.pod $installarchlib/perllocal.pod.bak ;
fi
perl Makefile.PL USE_APXS=1 WITH_APXS=`which apxs` EVERYTHING=1 APACHE_HEADER_INSTALL=1 ;
make ; 
make test ;

%install
install -d $RPM_BUILD_ROOT/%{perl_archlib}
install -d $RPM_BUILD_ROOT/%{apache_includedir}/modules/perl
install -d $RPM_BUILD_ROOT/%{apache_serverroot}/htdocs/gif
install -d $RPM_BUILD_ROOT/%{apache_sysconfdir}/modules
install -d $RPM_BUILD_ROOT/%{apache_libexecdir}
install -d $RPM_BUILD_ROOT/%{_var}/adm/fillup-templates
install -d $RPM_BUILD_ROOT/var/adm/perl-modules
install -d $RPM_BUILD_ROOT/%{apache_includedir}/modules/perl
make PREFIX=$RPM_BUILD_ROOT/usr \
     INSTALLMAN1DIR=$RPM_BUILD_ROOT/%{_mandir}/man1 \
     INSTALLMAN3DIR=$RPM_BUILD_ROOT/%{_mandir}/man3 \
     install
cp src/modules/perl/*.h $RPM_BUILD_ROOT/%{apache_includedir}/modules/perl/
install -m 644 %{name}.gif $RPM_BUILD_ROOT/%{apache_serverroot}/htdocs/gif
install -m 755 startup.perl $RPM_BUILD_ROOT/%{apache_includedir}/modules/perl/
cp -a %{apache_libexecdir}/libperl.so $RPM_BUILD_ROOT/%{apache_libexecdir}
#strip %{apache_libexecdir}/libperl.so
eval `perl -V:installarchlib`
mv $RPM_BUILD_ROOT/$installarchlib/perllocal.pod \
    $RPM_BUILD_ROOT//var/adm/perl-modules/%{name}
TEMPL=sysconfig.apache-%{name}
echo "#" > $TEMPL
echo "# enable the %{name} module (yes|no)" >> $TEMPL
echo "#" >> $TEMPL
echo "HTTPD_SEC_MOD_PERL=yes" >> $TEMPL
echo ""  >> $TEMPL
echo -e "Variable:HTTPD_SEC_MOD_PERL\nText:PERL\nLoadModule: LoadModule perl_module %{apache_libexecdir}/libperl.so\nAddModule: AddModule %{name}.c\n" \
        > $RPM_BUILD_ROOT/%{apache_sysconfdir}/modules/%{name}
install -m 644 $TEMPL \
	$RPM_BUILD_ROOT/%{_var}/adm/fillup-templates/
echo -e "LoadModule perl_module %{apache_libexecdir}/libperl.so\n" \
	> $RPM_BUILD_ROOT/%{apache_sysconfdir}/suse_loadmodule.conf
echo -e "AddModule %{name}.c\n" \
	> $RPM_BUILD_ROOT/%{apache_sysconfdir}/suse_addmodule.conf
cp -a $RPM_BUILD_ROOT/* /.
/usr/sbin/httpd -t         || exit 1
/usr/sbin/httpd -t -D PERL || exit 1

%post
%{fillup_only -an apache}

%files
%doc eg ToDo SUPPORT README MANIFEST INSTAL* Changes CREDITS
%doc apache-modlist.html htdocs/manual/mod/%{name}.html
#%doc Apache-%{name}_guide-1.28/rel/
%{apache_sysconfdir}/modules/%{name}
%{_var}/adm/fillup-templates/sysconfig.apache-%{name}
%{apache_libexecdir}/libperl.so
/var/adm/perl-modules/%{name}
%{apache_includedir}/modules/perl/
%{apache_serverroot}/htdocs/gif/%{name}.gif
%{_mandir}/man3/*
%{perl_sitearch}/auto/Apache
%{perl_sitearch}/*mod_perl*
%{perl_sitearch}/Apache.pm
%{perl_sitearch}/Bundle/Apache.pm
%{perl_sitearch}/Apache

%changelog -n mod_perl
* Sat Jul 20 2002 - poeml@suse.de
- detect the module magic number if provided by apache, indicating
  API changes, and add an RPM Require on it
* Thu Jan 17 2002 - ro@suse.de
- adapted for /etc/sysconfig/apache
* Thu Oct 25 2001 - ro@suse.de
- try neededforbuild alias apache-devel-packages
* Mon Jul 16 2001 - rolf@suse.de
- update to mod_perl 1.26
- update documentation to 1.29
* Thu Jun 21 2001 - ro@suse.de
- build-root and such get rid of using perl's packlist
  (contains only basenames starting with perl 5.6.1)
* Wed Apr 04 2001 - rolf@suse.de
- fixed problem with version detection of perl
* Wed Mar 28 2001 - rolf@suse.de
- update to mod_perl 1.25
- create module files for new Apache schema
- fixed bug in SuSE INET6 port
- mod_perl guide doesnt build due to missing pod2hpp
* Fri Feb 23 2001 - ro@suse.de
- changed neededforbuild <apache> to <apache apache-devel>
* Mon Nov 20 2000 - rolf@suse.de
- remove test.pl from cgi-bin for security reasons
- change group tag to "System Environment/Daemons"
- fix names of some perl modules
* Tue Nov 07 2000 - ro@suse.de
- fixed neededforbuild (perl_tie)
* Wed Oct 11 2000 - rolf@suse.de
- patched mod_perl to work with Apache IPv6 which needed some
  changes in the used socketaddr structures
* Mon Sep 25 2000 - ro@suse.de
- added perl_tie to neededforbuild and Requires
- added Apache-mod_perl_guide-1.24 html documentation
- perl = %%{version_perl} to Requires
* Tue Jun 20 2000 - ro@suse.de
- updated neededforbuild
* Wed May 17 2000 - rolf@suse.de
- update to 1.24
* Thu Apr 13 2000 - ro@suse.de
- added mm to neededforbuild
* Tue Mar 28 2000 - rolf@suse.de
- new version 1.22
* Mon Feb 28 2000 - rolf@suse.de
- some SPEC beautifications
* Wed Feb 23 2000 - rolf@suse.de
- fixed mandir
* Sat Nov 27 1999 - rolf@suse.de
- extract mod_perl from apache SRPM
- add startup.pl to package (Thanks to Ray for that hint).
- use .packlist to find all files
